%def_without static
%def_without milter

%define archver 0.83
%define clamconfdir /etc

Name: clamav
Version: 0.83
Release: alt0.M23.1
Summary: An anti-virus utility for Unix
License: GPL
URL: http://www.clamav.net/
Group: File tools
Packager: Victor Forsyuk <force@altlinux.ru>
Source0: http://download.sourceforge.net/clamav/clamav-%archver.tar.gz
Source1: clamav.init
Source2: clamav.sysconfig

Source4: freshclam.cron
Source5: freshclam.logrotate
Source6: clamav.logrotate

Source10: clamav-milter.init
Source11: clamav-milter.sysconfig
Source12: clamav-milter.msg
Source13: clamav-milter.whitelist

Source20: virusstat-perIP
Source21: virusstat-perIP-PrevHour
Source22: virusstat-total
Source23: virusstat.cron.example

Patch1: clamav-config.patch
Patch2: freshclam-config.patch

Patch10: clamav-milter-20040922-template.patch
Patch11: clamav-milter-20041206-ip-to-log.patch
Patch12: clamav-milter-0.83-log.patch

Patch100: clamav-milter-disable-session.patch

# Package with clamd should require libclamav, not vice versa.
# Corresponding libclamav version need to be updated before, or clamd restart may fail!
Requires: lib%{name} = %version-%release

# postinstall uses subst utility
Requires(post): sed >= 1:3.02-alt1

# Automatically added by buildreq on Tue Feb 08 2005
BuildRequires: bc bzlib-devel hostinfo libcurl-devel libgmp-devel libssl-devel zlib-devel

# sed used by configure script (not detectable by buildreq :()
BuildRequires: sed

# for snapshots
#BuildRequires: automake_1.8

%{?_with_static:BuildRequires: glibc-devel-static}
%{?_with_milter:BuildRequires: sendmail-common sendmail-devel sendmail-libs}

%description
Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose
of this software is the integration with mail servers (attachment
scanning). The package provides a flexible and scalable
multi-threaded daemon, a commandline scanner, and a tool for
automatic updating via Internet. The programs are based on a
shared library distributed with the Clam AntiVirus package, which
you can use in your own software.

%package -n lib%{name}
Summary: Shared libraries for clamav
Group: Development/C

%description -n lib%{name}
Shared libraries for clamav.

%package -n lib%{name}-devel
Summary: Development header files and libraries for clamav
Group: Development/C
Requires: %name = %version

%description -n lib%{name}-devel
This package contains the development header files and libraries
necessary to develop clamav client applications.

%package -n lib%{name}-devel-static
Summary: clamav static libraries
Group: Development/C
Requires: lib%{name}-devel = %version

%description -n lib%{name}-devel-static
clamav static libraries.

%package milter
Summary: clamav-milter for sendmail
Group: File tools
Requires: clamav = %version, sendmail

%description milter
This package contains the filter for Sendmail necessary to
integrate clamav with Sendmail MTA.


%prep
%setup -q -n clamav-%archver
%patch1 -p1
%patch2 -p1

%patch10 -p0
%patch11 -p0
%patch12 -p0

#%patch100 -p0

%build
%ifdef snap
aclocal
%endif

# --disable-clamav: Disable test for clamav user/group
%configure \
	--sysconfdir=%clamconfdir \
	--disable-clamav \
	--with-user=mail \
	--with-group=mail \
	--without-tcpwrappers \
	--with-libcurl \
	--with-dbdir=/var/lib/%name %{?_with_milter: --enable-milter}
%make_build

install -m644 %_sourcedir/virusstat* .

%install
make install DESTDIR=$RPM_BUILD_ROOT

%{!?_with_milter:rm -f $RPM_BUILD_ROOT/usr/share/man/man1/clamav-milter*}

install -d $RPM_BUILD_ROOT%{_sysconfdir}/{rc.d/init.d,sysconfig,cron.d,logrotate.d}
install -d $RPM_BUILD_ROOT%{_var}/log/clamav

install -m755 %_sourcedir/clamav.init $RPM_BUILD_ROOT/etc/rc.d/init.d/clamd
install -m755 %_sourcedir/clamav-milter.init $RPM_BUILD_ROOT/etc/rc.d/init.d/clamav-milter

install %_sourcedir/clamav.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/clamd
install %_sourcedir/clamav-milter.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/clamav-milter

touch $RPM_BUILD_ROOT%{_var}/log/clamav/clamd.log
touch $RPM_BUILD_ROOT%{_var}/log/clamav/freshclam.log

# install the logrotate stuff
install -m644 %_sourcedir/freshclam.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/freshclam
install -m644 %_sourcedir/clamav.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/clamav

# install config files _explicitly_
# they will not be installed by 'make install' if exists in build system :-\
install -m644 etc/clamd.conf $RPM_BUILD_ROOT%clamconfdir/
install -m644 etc/freshclam.conf $RPM_BUILD_ROOT%clamconfdir/

install -m644 %_sourcedir/clamav-milter.msg $RPM_BUILD_ROOT%clamconfdir/
install -m644 %_sourcedir/clamav-milter.whitelist $RPM_BUILD_ROOT%clamconfdir/

# pid file dir
install -d $RPM_BUILD_ROOT/var/run/clamav

# remove non-packaged files
%__rm -f %buildroot%_libdir/*.la
%__rm -f %buildroot/var/lib/clamav/*.cvd
%__rm -rf docs/html/CVS
%if_without static
%__rm -f %buildroot%_libdir/*.a
%endif

cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/cron.d/freshclam
30 * * * *       root    %_bindir/freshclam --quiet --daemon-notify
EOF

%post
# virus db format changed with 0.65, so delete old databases
%__rm -f /var/lib/clamav/viruses.db*

%post_service clamd

# randomize time of database updating (in order to distribute load on servers evenly)
RNDM=$[$RANDOM/555]
/usr/bin/subst s/^[0-9]*/$RNDM/ %_sysconfdir/cron.d/freshclam

%preun
%preun_service clamd

%post -n lib%{name} -p %post_ldconfig
%postun -n lib%{name} -p %postun_ldconfig

%post milter
%post_service clamav-milter

%preun milter
%preun_service clamav-milter

%files
# NEWS and README - identical files :-\
%doc AUTHORS BUGS ChangeLog FAQ README docs/clamdoc.*
%doc docs/signatures.*
%doc virusstat*
%doc docs/html

%_bindir/clamdscan
%_bindir/clamscan
%_bindir/freshclam
%_bindir/sigtool
%_sbindir/clamd
%config(noreplace) %_initdir/clamd
%config(noreplace) %verify(not md5 size mtime) %clamconfdir/*.conf
%config(noreplace) %_sysconfdir/logrotate.d/clamav
%attr(640,root,root) %config(noreplace) %verify(not md5 size mtime) /etc/sysconfig/clamd
%_man1dir/clamdscan*
%_man1dir/clamscan*
%_man1dir/freshclam*
%_man1dir/sigtool*
%_man5dir/*
%_man8dir/clamd*
%attr(3775,root,mail) %dir /var/lib/clamav
%attr(3775,root,mail) %dir /var/run/clamav
%attr(3771,root,mail) %dir /var/log/clamav
%attr(640,mail,root) %ghost /var/log/clamav/clamd.log
%attr(644,mail,mail) %ghost /var/log/clamav/freshclam.log
%config(noreplace) %_sysconfdir/cron.d/freshclam
%config(noreplace) %_sysconfdir/logrotate.d/freshclam

%files -n lib%{name}
%_libdir/lib*.so.*

%files -n lib%{name}-devel
%_bindir/clamav-config
%_libdir/lib*.so
%_libdir/pkgconfig/*
%_includedir/*.h

%if_with static
%files -n lib%{name}-devel-static
%_libdir/lib*.a
%endif

%if_with milter
%files milter
%_sbindir/clamav-milter
%config(noreplace) %_initdir/clamav-milter
%config(noreplace) %verify(not md5 size mtime) /etc/sysconfig/clamav-milter
%config(noreplace) %verify(not md5 size mtime) %clamconfdir/*.msg
%config(noreplace) %verify(not md5 size mtime) %clamconfdir/*.whitelist
%_man8dir/clamav-milter.*
%endif

%changelog
* Sun Apr 10 2005 Michael Shigorin <mike@altlinux.ru> 0.83-alt0.M23.1
- built for 2.3
- removed IDN support
- removed milter support

* Fri Feb 18 2005 Sergey Y. Afonin <asy@altlinux.ru> 0.83-alt0.M24.1
- 0.83, Master 2.4 update.
- fix: path to clamd.conf in freshclam config
- disable clamav-milter-disable-session.patch (disabled by default)

* Tue Feb 08 2005 Sergey Y. Afonin <asy@altlinux.ru> 0.82-alt0.M24.1
- 0.82, Master 2.4 update.
- Disable SESSION in clamav-milter.

* Fri Jan 28 2005 Sergey Y. Afonin <asy@altlinux.ru> 0.81-alt1.M24.1
- 0.81, Master 2.4 update.
- Move config files to /etc.
- fix clamav-milter-0.81-log.patch for 0.81.

* Thu Jan 27 2005 Victor Forsyuk <force@altlinux.ru> 0.81-alt2
- 0.81.
- Fix from Sergey Afonin: add `bc' to BuildRequires.
- Patch to fix freshclam error with buggy proxy servers (that answers
  in HTTP/1.0 when we requested HTTP/1.1).

* Fri Jan 21 2005 Victor Forsyuk <force@altlinux.ru> 0.81-alt1.rc1
- 0.81rc1.
- Address BTS #5377.

* Fri Oct 29 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt4
- Check for database updates hourly.
- Fix path to config file in NotifyClamd.

* Mon Oct 18 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt3
- 0.80.
- Patches from Sergey Afonin.

* Tue Oct 12 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt2.rc4
- Mark clamav-milter startup script as noreplaced config.
- Small fix in database updating time randomizer.
- Modify clamav-milter sysconfig file.
- Move config files to /etc/clamav.
- Tweak initscripts priorities to start clamd before clamav-milter
  and both of them before MTA.

* Wed Sep 29 2004 Victor Forsyuk <force@altlinux.ru> 0.80-alt1.rc3
- 0.80rc3.

* Mon Aug 30 2004 Victor Forsyuk <force@altlinux.ru> 0.75.1-alt2
- Build --without-tcpwrappers to fix bug #5064.

* Mon Aug 02 2004 Victor Forsyuk <force@altlinux.ru> 0.75.1-alt1
- 0.75.1

* Fri Jun 25 2004 Victor Forsyuk <force@altlinux.ru> 0.73-alt1
- 0.73.
- Add pkgconfig file and clamav-config to -devel package.

* Wed May 19 2004 Victor Forsyuk <force@altlinux.ru> 0.71-alt1
- New version.

* Wed Apr 21 2004 Victor Forsyuk <force@altlinux.ru> 0.70-alt2
- New version.
- Freshclam launching time randomized at package installation.
  Thanks to Sergey Afonin <asy <at> kraft-s.ru> for idea.

* Wed Apr 14 2004 Victor Forsyuk <force@altlinux.ru> 0.70-alt1.20040414
- Build (post-0.70rc) snapshot from 2004/04/14.

* Mon Mar 01 2004 Victor Forsyuk <force@altlinux.ru> 0.67-alt2.20040301
- Build snapshot from 2004/03/01.
- Fix logrotate for clamd logs.
- Add --daemon-notify to options freshclam run with.
- Add build with milter and create clamav-milter subpackage.

* Sun Feb 15 2004 Victor Forsyuk <force@altlinux.ru> 0.67-alt1
- New version.
- Checks for new database every two hours (suggested by clamav authors).
- Rotate logs weekly (was monthly).

* Thu Dec 18 2003 Victor Forsyuk <force@altlinux.ru> 0.65-alt0.1
- New version.
- Removed *.la files.
- Do not build devel-static subpackage by default.

* Fri Jun 27 2003 Victor Forsyuk <force@altlinux.ru> 0.60-alt1
- Initial build for Sisyphus.
